diff --git a/package/libs/librpc/Makefile b/package/libs/librpc/Makefile
index 0330614c31..e8f51a23f1 100644
--- a/package/libs/librpc/Makefile
+++ b/package/libs/librpc/Makefile
@@ -4,7 +4,7 @@ PKG_NAME:=librpc
 PKG_RELEASE=1
 
 PKG_SOURCE_PROTO:=git
-PKG_SOURCE_URL=$(LEDE_GIT)/project/librpc-uclibc.git
+PKG_SOURCE_URL=$(PROJECT_GIT)/project/librpc-uclibc.git
 PKG_SOURCE_DATE:=2015-11-04
 PKG_SOURCE_VERSION:=a921e3ded051746f9f7cd5e5a312fb6771716aac
 PKG_MIRROR_HASH:=22c8dc55e1c4e8e31635a37708a3ce622a6ca33ebd918a4321b0be6ffce89b21
diff --git a/package/libs/libubox/Makefile b/package/libs/libubox/Makefile
index b261430e2d..6121576103 100644
--- a/package/libs/libubox/Makefile
+++ b/package/libs/libubox/Makefile
@@ -4,7 +4,7 @@ PKG_NAME:=libubox
 PKG_RELEASE=1
 
 PKG_SOURCE_PROTO:=git
-PKG_SOURCE_URL=$(LEDE_GIT)/project/libubox.git
+PKG_SOURCE_URL=$(PROJECT_GIT)/project/libubox.git
 PKG_SOURCE_DATE:=2017-10-06
 PKG_SOURCE_VERSION:=729f47fd5279f902986457682f8f166c324eafb5
 PKG_MIRROR_HASH:=5ca03294498f347f437236aeb1d55747264229a46a5ddba93caeb6b3fb735e10
diff --git a/package/libs/uclient/Makefile b/package/libs/uclient/Makefile
index 3eefa2e012..f0c08a3233 100644
--- a/package/libs/uclient/Makefile
+++ b/package/libs/uclient/Makefile
@@ -4,7 +4,7 @@ PKG_NAME:=uclient
 PKG_RELEASE=1
 
 PKG_SOURCE_PROTO:=git
-PKG_SOURCE_URL=$(LEDE_GIT)/project/uclient.git
+PKG_SOURCE_URL=$(PROJECT_GIT)/project/uclient.git
 PKG_SOURCE_DATE:=2017-11-02
 PKG_SOURCE_VERSION:=4b87d83160fec70d50b7fcd736a8c538c28a016c
 PKG_MIRROR_HASH:=4bbb4d5f295ebdcd67fec87a6794168bea2176a42cb2907c47d8566fb33dafb3
diff --git a/package/libs/ustream-ssl/Makefile b/package/libs/ustream-ssl/Makefile
index 7afbeeba66..b5e773ba7f 100644
--- a/package/libs/ustream-ssl/Makefile
+++ b/package/libs/ustream-ssl/Makefile
@@ -4,7 +4,7 @@ PKG_NAME:=ustream-ssl
 PKG_RELEASE:=2
 
 PKG_SOURCE_PROTO:=git
-PKG_SOURCE_URL=$(LEDE_GIT)/project/ustream-ssl.git
+PKG_SOURCE_URL=$(PROJECT_GIT)/project/ustream-ssl.git
 PKG_SOURCE_DATE:=2016-07-02
 PKG_SOURCE_VERSION:=ec80adaa1b47f28d426fa19c692011ce60b992d6
 PKG_MIRROR_HASH:=bfbad6b4e8c1e933f0bfaab43cbdd44a536c08128c3a779e6f2395a6a886aab7
diff --git a/package/network/config/firewall/Makefile b/package/network/config/firewall/Makefile
index 06e67543b9..1bc2c4d1fa 100644
--- a/package/network/config/firewall/Makefile
+++ b/package/network/config/firewall/Makefile
@@ -12,7 +12,7 @@ PKG_NAME:=firewall
 PKG_RELEASE:=1
 
 PKG_SOURCE_PROTO:=git
-PKG_SOURCE_URL=$(LEDE_GIT)/project/firewall3.git
+PKG_SOURCE_URL=$(PROJECT_GIT)/project/firewall3.git
 PKG_SOURCE_DATE:=2017-11-07
 PKG_SOURCE_VERSION:=c4309372acc7e1bef8aa230269f7da1dec790e68
 PKG_MIRROR_HASH:=1699884d8499d01e433959185f79ff9eb69704de47885b996123374b8015b422
diff --git a/package/network/config/netifd/Makefile b/package/network/config/netifd/Makefile
index 4eb4737a3a..ade0061e7a 100644
--- a/package/network/config/netifd/Makefile
+++ b/package/network/config/netifd/Makefile
@@ -4,7 +4,7 @@ PKG_NAME:=netifd
 PKG_RELEASE:=1
 
 PKG_SOURCE_PROTO:=git
-PKG_SOURCE_URL=$(LEDE_GIT)/project/netifd.git
+PKG_SOURCE_URL=$(PROJECT_GIT)/project/netifd.git
 PKG_SOURCE_DATE:=2018-01-04
 PKG_SOURCE_VERSION:=fd5c399c01ceb1bbede3ae8b0e1daaa7652a6fa1
 PKG_MIRROR_HASH:=0040f94d11d0039505328a90b2ff48968db873e9e7967307631bf40ef5679275
diff --git a/package/network/ipv6/odhcp6c/Makefile b/package/network/ipv6/odhcp6c/Makefile
index 457a871efb..24cbe0b2cb 100644
--- a/package/network/ipv6/odhcp6c/Makefile
+++ b/package/network/ipv6/odhcp6c/Makefile
@@ -11,7 +11,7 @@ PKG_NAME:=odhcp6c
 PKG_RELEASE:=4
 
 PKG_SOURCE_PROTO:=git
-PKG_SOURCE_URL=$(LEDE_GIT)/project/odhcp6c.git
+PKG_SOURCE_URL=$(PROJECT_GIT)/project/odhcp6c.git
 PKG_SOURCE_DATE:=2017-09-05
 PKG_SOURCE_VERSION:=51733a6d3bfe0fb9e8c53aea22231e5b8a1f64c3
 PKG_MIRROR_HASH:=fdccfb9a6cb00d6dbf1a3160bd36622ee8e188a9d58bcd282c71a9368972e184
diff --git a/package/network/services/odhcpd/Makefile b/package/network/services/odhcpd/Makefile
index 2a22cd874e..16c903db36 100644
--- a/package/network/services/odhcpd/Makefile
+++ b/package/network/services/odhcpd/Makefile
@@ -12,7 +12,7 @@ PKG_RELEASE:=1
 PKG_VERSION:=1.3
 
 PKG_SOURCE_PROTO:=git
-PKG_SOURCE_URL=$(LEDE_GIT)/project/odhcpd.git
+PKG_SOURCE_URL=$(PROJECT_GIT)/project/odhcpd.git
 PKG_SOURCE_DATE:=2017-12-22
 PKG_SOURCE_VERSION:=7aa2594c5a127d92fa8f04328ac7b43e595bcaa7
 PKG_MIRROR_HASH:=67ce9303ce2f7a47ca9c54e1ebd984f108066ab0fa4e0d81f39a9cfc2431f90b
diff --git a/package/network/services/relayd/Makefile b/package/network/services/relayd/Makefile
index dcb69a11b5..7f1c1f9415 100644
--- a/package/network/services/relayd/Makefile
+++ b/package/network/services/relayd/Makefile
@@ -10,7 +10,7 @@ include $(TOPDIR)/rules.mk
 PKG_NAME:=relayd
 PKG_RELEASE:=2
 
-PKG_SOURCE_URL=$(LEDE_GIT)/project/relayd.git
+PKG_SOURCE_URL=$(PROJECT_GIT)/project/relayd.git
 PKG_SOURCE_PROTO:=git
 PKG_SOURCE_DATE:=2016-02-07
 PKG_SOURCE_VERSION:=ad0b25ad74345d367c62311e14b279f5ccb8ef13
diff --git a/package/network/services/uhttpd/Makefile b/package/network/services/uhttpd/Makefile
index f2d061c095..648916385c 100644
--- a/package/network/services/uhttpd/Makefile
+++ b/package/network/services/uhttpd/Makefile
@@ -11,7 +11,7 @@ PKG_NAME:=uhttpd
 PKG_RELEASE:=1
 
 PKG_SOURCE_PROTO:=git
-PKG_SOURCE_URL=$(LEDE_GIT)/project/uhttpd.git
+PKG_SOURCE_URL=$(PROJECT_GIT)/project/uhttpd.git
 PKG_SOURCE_DATE:=2017-11-04
 PKG_SOURCE_VERSION:=a235636a2687fafb9c474e4b134a59ff66425c92
 PKG_MIRROR_HASH:=626392a485e8ab8085bb55d9424b176be9143529db59a820a7de71061a93a007
diff --git a/package/network/services/umdns/Makefile b/package/network/services/umdns/Makefile
index 7fae197fec..ffbc3fed35 100644
--- a/package/network/services/umdns/Makefile
+++ b/package/network/services/umdns/Makefile
@@ -10,7 +10,7 @@ include $(TOPDIR)/rules.mk
 PKG_NAME:=umdns
 PKG_RELEASE:=1
 
-PKG_SOURCE_URL=$(LEDE_GIT)/project/mdnsd.git
+PKG_SOURCE_URL=$(PROJECT_GIT)/project/mdnsd.git
 PKG_SOURCE_PROTO:=git
 PKG_SOURCE_DATE:=2018-01-02
 PKG_SOURCE_VERSION:=78974417e182a3de8f78b7d73366ec0c98396b6c
diff --git a/package/network/utils/iwinfo/Makefile b/package/network/utils/iwinfo/Makefile
index 1b8a3ad2bc..453978eb92 100644
--- a/package/network/utils/iwinfo/Makefile
+++ b/package/network/utils/iwinfo/Makefile
@@ -10,7 +10,7 @@ PKG_NAME:=libiwinfo
 PKG_RELEASE:=1
 
 PKG_SOURCE_PROTO:=git
-PKG_SOURCE_URL=$(LEDE_GIT)/project/iwinfo.git
+PKG_SOURCE_URL=$(PROJECT_GIT)/project/iwinfo.git
 PKG_SOURCE_DATE:=2017-08-23
 PKG_SOURCE_VERSION:=c1a03e8231a5d8b348b70a182d256725c98a3b0b
 PKG_MIRROR_HASH:=7bd294f50f8ec8c0497c5fbe5527f3ae098814cdfeecf4ccf78a2a8937611664
diff --git a/package/network/utils/umbim/Makefile b/package/network/utils/umbim/Makefile
index 616a02367c..4faa5acf90 100644
--- a/package/network/utils/umbim/Makefile
+++ b/package/network/utils/umbim/Makefile
@@ -4,7 +4,7 @@ PKG_NAME:=umbim
 PKG_RELEASE:=1
 
 PKG_SOURCE_PROTO:=git
-PKG_SOURCE_URL=$(LEDE_GIT)/project/umbim.git
+PKG_SOURCE_URL=$(PROJECT_GIT)/project/umbim.git
 PKG_SOURCE_DATE:=2015-07-04
 PKG_SOURCE_VERSION:=29aaf43b097ee57f7aa1bb24341db6cc4148cbf3
 PKG_MIRROR_HASH:=56e612d9da1ac26de96c4929fbabd047862d725a13ceb904807a9d3d7db43a30
diff --git a/package/network/utils/uqmi/Makefile b/package/network/utils/uqmi/Makefile
index 6e891435b9..16e4a5a911 100644
--- a/package/network/utils/uqmi/Makefile
+++ b/package/network/utils/uqmi/Makefile
@@ -4,7 +4,7 @@ PKG_NAME:=uqmi
 PKG_RELEASE:=2
 
 PKG_SOURCE_PROTO:=git
-PKG_SOURCE_URL=$(LEDE_GIT)/project/uqmi.git
+PKG_SOURCE_URL=$(PROJECT_GIT)/project/uqmi.git
 PKG_SOURCE_DATE:=2016-12-19
 PKG_SOURCE_VERSION:=8ceeab690d8c6f1e3afbd4bcaee7bc2ba3fbe165
 PKG_MIRROR_HASH:=b3637ff04e51769137af1c5e173e73311e11c3c2dcc49eeaca6aa3520f61d247
diff --git a/package/system/fstools/Makefile b/package/system/fstools/Makefile
index 61fc5daa8b..5ad3dd21ec 100644
--- a/package/system/fstools/Makefile
+++ b/package/system/fstools/Makefile
@@ -11,7 +11,7 @@ PKG_NAME:=fstools
 PKG_RELEASE:=1
 
 PKG_SOURCE_PROTO:=git
-PKG_SOURCE_URL=$(LEDE_GIT)/project/fstools.git
+PKG_SOURCE_URL=$(PROJECT_GIT)/project/fstools.git
 PKG_SOURCE_DATE:=2018-01-02
 PKG_SOURCE_VERSION:=11efbf3b90f031ce634fc38cad07a4aef2985777
 PKG_MIRROR_HASH:=35f14ea0ed799d2eb972f4901116a0e447d4bc1e37fb0edb239c44b270aeae18
diff --git a/package/system/lede-keyring/Makefile b/package/system/lede-keyring/Makefile
index fb5752a54e..d0961b1626 100644
--- a/package/system/lede-keyring/Makefile
+++ b/package/system/lede-keyring/Makefile
@@ -6,7 +6,7 @@ PKG_NAME:=lede-keyring
 PKG_RELEASE:=1
 
 PKG_SOURCE_PROTO:=git
-PKG_SOURCE_URL=$(LEDE_GIT)/keyring.git
+PKG_SOURCE_URL=$(PROJECT_GIT)/keyring.git
 PKG_SOURCE_DATE:=2017-01-20
 PKG_SOURCE_VERSION:=a50b7529880988ca96e72dede0279ff139a8ab1a
 PKG_MIRROR_HASH:=811ba79ba71925e949d2c690db7d7b031ac1dd965aa831ca9b6d9d70f5657254
diff --git a/package/system/procd/Makefile b/package/system/procd/Makefile
index 7c8a1669b0..d615dd01d1 100644
--- a/package/system/procd/Makefile
+++ b/package/system/procd/Makefile
@@ -11,7 +11,7 @@ PKG_NAME:=procd
 PKG_RELEASE:=2
 
 PKG_SOURCE_PROTO:=git
-PKG_SOURCE_URL=$(LEDE_GIT)/project/procd.git
+PKG_SOURCE_URL=$(PROJECT_GIT)/project/procd.git
 PKG_SOURCE_DATE:=2018-12-02
 PKG_SOURCE_VERSION:=a5954cf302fe46d8e29770c818336763112b9a6e
 PKG_MIRROR_HASH:=1afa1f0160dd8ffac310e75519601c1f9a6107d818f405bb3fe9ef3e7143c2e3
diff --git a/package/system/rpcd/Makefile b/package/system/rpcd/Makefile
index dc4bbb9829..2dc960e48d 100644
--- a/package/system/rpcd/Makefile
+++ b/package/system/rpcd/Makefile
@@ -11,7 +11,7 @@ PKG_NAME:=rpcd
 PKG_RELEASE:=1
 
 PKG_SOURCE_PROTO:=git
-PKG_SOURCE_URL=$(LEDE_GIT)/project/rpcd.git
+PKG_SOURCE_URL=$(PROJECT_GIT)/project/rpcd.git
 PKG_SOURCE_DATE:=2017-12-07
 PKG_SOURCE_VERSION:=cfe1e75c91bc1bac82e6caab3e652b0ebee59524
 PKG_MAINTAINER:=Jo-Philipp Wich <jo@mein.io>
diff --git a/package/system/ubox/Makefile b/package/system/ubox/Makefile
index 21119ee6df..299872ed44 100644
--- a/package/system/ubox/Makefile
+++ b/package/system/ubox/Makefile
@@ -4,7 +4,7 @@ PKG_NAME:=ubox
 PKG_RELEASE:=1
 
 PKG_SOURCE_PROTO:=git
-PKG_SOURCE_URL=$(LEDE_GIT)/project/ubox.git
+PKG_SOURCE_URL=$(PROJECT_GIT)/project/ubox.git
 PKG_SOURCE_DATE:=2017-11-06
 PKG_SOURCE_VERSION:=2c0d9cfe05e9712d44622c6bb4558e97359bfb76
 PKG_MIRROR_HASH:=e545a29959a310fd7243ee2e799bf9f759894ea4e872010a781c3a65290377b6
diff --git a/package/system/ubus/Makefile b/package/system/ubus/Makefile
index ce8b054b4e..39854f48f8 100644
--- a/package/system/ubus/Makefile
+++ b/package/system/ubus/Makefile
@@ -4,7 +4,7 @@ PKG_NAME:=ubus
 PKG_RELEASE:=1
 
 PKG_SOURCE_PROTO:=git
-PKG_SOURCE_URL=$(LEDE_GIT)/project/ubus.git
+PKG_SOURCE_URL=$(PROJECT_GIT)/project/ubus.git
 PKG_SOURCE_DATE:=2017-11-13
 PKG_SOURCE_VERSION:=5f87f5480ebf004d735dbf44259d08cf8affd305
 PKG_MIRROR_HASH:=a490348da86c6cdf0cbc8cc01b77fa6f708d86b94674fd312e0c822ca3d7eba0
diff --git a/package/system/uci/Makefile b/package/system/uci/Makefile
index d4718ee90b..d5b4eac4aa 100644
--- a/package/system/uci/Makefile
+++ b/package/system/uci/Makefile
@@ -11,7 +11,7 @@ include $(TOPDIR)/rules.mk
 PKG_NAME:=uci
 PKG_RELEASE:=1
 
-PKG_SOURCE_URL=$(LEDE_GIT)/project/uci.git
+PKG_SOURCE_URL=$(PROJECT_GIT)/project/uci.git
 PKG_SOURCE_PROTO:=git
 PKG_SOURCE_DATE=2018-01-01
 PKG_SOURCE_VERSION:=5beb95da3dbec6db11a6bdfaab7807ee2daf41e6
diff --git a/package/system/usign/Makefile b/package/system/usign/Makefile
index 84adccb4a3..63f9f09953 100644
--- a/package/system/usign/Makefile
+++ b/package/system/usign/Makefile
@@ -4,7 +4,7 @@ PKG_NAME:=usign
 PKG_RELEASE:=1
 
 PKG_SOURCE_PROTO:=git
-PKG_SOURCE_URL=$(LEDE_GIT)/project/usign.git
+PKG_SOURCE_URL=$(PROJECT_GIT)/project/usign.git
 PKG_SOURCE_DATE:=2015-07-04
 PKG_SOURCE_VERSION:=ef6419142a3b0fbcddcccf536e3c1880302c6f89
 PKG_MIRROR_HASH:=9499ed7e40889b364e446a428e185c40986b75087888bd7e1496542457a6dbaa
diff --git a/package/utils/jsonfilter/Makefile b/package/utils/jsonfilter/Makefile
index b70928ba53..32be1adb94 100644
--- a/package/utils/jsonfilter/Makefile
+++ b/package/utils/jsonfilter/Makefile
@@ -4,7 +4,7 @@ PKG_NAME:=jsonfilter
 PKG_RELEASE:=1
 
 PKG_SOURCE_PROTO:=git
-PKG_SOURCE_URL=$(LEDE_GIT)/project/jsonpath.git
+PKG_SOURCE_URL=$(PROJECT_GIT)/project/jsonpath.git
 PKG_SOURCE_DATE:=2016-07-02
 PKG_SOURCE_VERSION:=dea067ad67d977c247c300c06676a06adf21e0c7
 PKG_MIRROR_HASH:=6c0e30da3f0c82527f9b5285d7c6ae61406732f2b0543b93131fe115ffc2987a
diff --git a/package/utils/ugps/Makefile b/package/utils/ugps/Makefile
index 1dad863fd8..3a972f54df 100644
--- a/package/utils/ugps/Makefile
+++ b/package/utils/ugps/Makefile
@@ -10,7 +10,7 @@ include $(TOPDIR)/rules.mk
 PKG_NAME:=ugps
 PKG_RELEASE:=3
 
-PKG_SOURCE_URL=$(LEDE_GIT)/project/ugps.git
+PKG_SOURCE_URL=$(PROJECT_GIT)/project/ugps.git
 PKG_SOURCE_PROTO:=git
 PKG_SOURCE_DATE:=2017-02-11
 PKG_SOURCE_VERSION:=c30055a685bca1e81ccc8f4bd3bb08d780a7d762
diff --git a/package/utils/usbmode/Makefile b/package/utils/usbmode/Makefile
index 2560f1c409..e229c791c0 100644
--- a/package/utils/usbmode/Makefile
+++ b/package/utils/usbmode/Makefile
@@ -4,7 +4,7 @@ PKG_NAME:=usbmode
 PKG_RELEASE:=1
 
 PKG_SOURCE_PROTO:=git
-PKG_SOURCE_URL=$(LEDE_GIT)/project/usbmode.git
+PKG_SOURCE_URL=$(PROJECT_GIT)/project/usbmode.git
 PKG_SOURCE_DATE:=2017-12-19
 PKG_SOURCE_VERSION:=f40f84c27534159066c94dadc0c08e0b255c3e26
 PKG_MIRROR_HASH:=840c7ee2843102b09d8943a20820025251cc259385e2b0bde6b7c8cce8190f83